package com.tzld.piaoquan.abtest.web;

import com.tzld.piaoquan.abtest.client.ProtobufUtils;
import com.tzld.piaoquan.abtest.client.model.GetExpRequest;
import com.tzld.piaoquan.abtest.client.model.GetExpResponse;
import com.tzld.piaoquan.abtest.service.ExpService;
import lombok.extern.slf4j.Slf4j;
import org.slf4j.MDC;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author dyp
 */
@RestController
@Slf4j
public class ExpController {
    @Autowired
    private ExpService expService;

    @RequestMapping("/exp/getExp")
    public String getExp(@RequestBody GetExpRequest httpRequest) {
        MDC.put("appType", String.valueOf(httpRequest.getAppType()));
        GetExpResponse response = expService.getExp(httpRequest);
        return ProtobufUtils.toJson(response);
    }
}
