package com.tzld.piaoquan.abtest.client.model;

import static io.grpc.MethodDescriptor.generateFullMethodName;
import static io.grpc.stub.ClientCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ClientCalls.asyncClientStreamingCall;
import static io.grpc.stub.ClientCalls.asyncServerStreamingCall;
import static io.grpc.stub.ClientCalls.asyncUnaryCall;
import static io.grpc.stub.ClientCalls.blockingServerStreamingCall;
import static io.grpc.stub.ClientCalls.blockingUnaryCall;
import static io.grpc.stub.ClientCalls.futureUnaryCall;
import static io.grpc.stub.ServerCalls.asyncBidiStreamingCall;
import static io.grpc.stub.ServerCalls.asyncClientStreamingCall;
import static io.grpc.stub.ServerCalls.asyncServerStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnaryCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedStreamingCall;
import static io.grpc.stub.ServerCalls.asyncUnimplementedUnaryCall;

/**
 */
@javax.annotation.Generated(
    value = "by gRPC proto compiler (version 1.34.1)",
    comments = "Source: com/tzld/piaoquan/abtest/exp.proto")
public final class ExpServiceGrpc {

  private ExpServiceGrpc() {}

  public static final String SERVICE_NAME = "ExpService";

  // Static method descriptors that strictly reflect the proto.
  private static volatile io.grpc.MethodDescriptor<com.tzld.piaoquan.abtest.client.model.GetExpRequest,
      com.tzld.piaoquan.abtest.client.model.GetExpResponse> getGetExpMethod;

  @io.grpc.stub.annotations.RpcMethod(
      fullMethodName = SERVICE_NAME + '/' + "getExp",
      requestType = com.tzld.piaoquan.abtest.client.model.GetExpRequest.class,
      responseType = com.tzld.piaoquan.abtest.client.model.GetExpResponse.class,
      methodType = io.grpc.MethodDescriptor.MethodType.UNARY)
  public static io.grpc.MethodDescriptor<com.tzld.piaoquan.abtest.client.model.GetExpRequest,
      com.tzld.piaoquan.abtest.client.model.GetExpResponse> getGetExpMethod() {
    io.grpc.MethodDescriptor<com.tzld.piaoquan.abtest.client.model.GetExpRequest, com.tzld.piaoquan.abtest.client.model.GetExpResponse> getGetExpMethod;
    if ((getGetExpMethod = ExpServiceGrpc.getGetExpMethod) == null) {
      synchronized (ExpServiceGrpc.class) {
        if ((getGetExpMethod = ExpServiceGrpc.getGetExpMethod) == null) {
          ExpServiceGrpc.getGetExpMethod = getGetExpMethod =
              io.grpc.MethodDescriptor.<com.tzld.piaoquan.abtest.client.model.GetExpRequest, com.tzld.piaoquan.abtest.client.model.GetExpResponse>newBuilder()
              .setType(io.grpc.MethodDescriptor.MethodType.UNARY)
              .setFullMethodName(generateFullMethodName(SERVICE_NAME, "getExp"))
              .setSampledToLocalTracing(true)
              .setRequestMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.tzld.piaoquan.abtest.client.model.GetExpRequest.getDefaultInstance()))
              .setResponseMarshaller(io.grpc.protobuf.ProtoUtils.marshaller(
                  com.tzld.piaoquan.abtest.client.model.GetExpResponse.getDefaultInstance()))
              .setSchemaDescriptor(new ExpServiceMethodDescriptorSupplier("getExp"))
              .build();
        }
      }
    }
    return getGetExpMethod;
  }

  /**
   * Creates a new async stub that supports all call types for the service
   */
  public static ExpServiceStub newStub(io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<ExpServiceStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<ExpServiceStub>() {
        @java.lang.Override
        public ExpServiceStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new ExpServiceStub(channel, callOptions);
        }
      };
    return ExpServiceStub.newStub(factory, channel);
  }

  /**
   * Creates a new blocking-style stub that supports unary and streaming output calls on the service
   */
  public static ExpServiceBlockingStub newBlockingStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<ExpServiceBlockingStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<ExpServiceBlockingStub>() {
        @java.lang.Override
        public ExpServiceBlockingStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new ExpServiceBlockingStub(channel, callOptions);
        }
      };
    return ExpServiceBlockingStub.newStub(factory, channel);
  }

  /**
   * Creates a new ListenableFuture-style stub that supports unary calls on the service
   */
  public static ExpServiceFutureStub newFutureStub(
      io.grpc.Channel channel) {
    io.grpc.stub.AbstractStub.StubFactory<ExpServiceFutureStub> factory =
      new io.grpc.stub.AbstractStub.StubFactory<ExpServiceFutureStub>() {
        @java.lang.Override
        public ExpServiceFutureStub newStub(io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
          return new ExpServiceFutureStub(channel, callOptions);
        }
      };
    return ExpServiceFutureStub.newStub(factory, channel);
  }

  /**
   */
  public static abstract class ExpServiceImplBase implements io.grpc.BindableService {

    /**
     */
    public void getExp(com.tzld.piaoquan.abtest.client.model.GetExpRequest request,
        io.grpc.stub.StreamObserver<com.tzld.piaoquan.abtest.client.model.GetExpResponse> responseObserver) {
      asyncUnimplementedUnaryCall(getGetExpMethod(), responseObserver);
    }

    @java.lang.Override public final io.grpc.ServerServiceDefinition bindService() {
      return io.grpc.ServerServiceDefinition.builder(getServiceDescriptor())
          .addMethod(
            getGetExpMethod(),
            asyncUnaryCall(
              new MethodHandlers<
                com.tzld.piaoquan.abtest.client.model.GetExpRequest,
                com.tzld.piaoquan.abtest.client.model.GetExpResponse>(
                  this, METHODID_GET_EXP)))
          .build();
    }
  }

  /**
   */
  public static final class ExpServiceStub extends io.grpc.stub.AbstractAsyncStub<ExpServiceStub> {
    private ExpServiceStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected ExpServiceStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new ExpServiceStub(channel, callOptions);
    }

    /**
     */
    public void getExp(com.tzld.piaoquan.abtest.client.model.GetExpRequest request,
        io.grpc.stub.StreamObserver<com.tzld.piaoquan.abtest.client.model.GetExpResponse> responseObserver) {
      asyncUnaryCall(
          getChannel().newCall(getGetExpMethod(), getCallOptions()), request, responseObserver);
    }
  }

  /**
   */
  public static final class ExpServiceBlockingStub extends io.grpc.stub.AbstractBlockingStub<ExpServiceBlockingStub> {
    private ExpServiceBlockingStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected ExpServiceBlockingStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new ExpServiceBlockingStub(channel, callOptions);
    }

    /**
     */
    public com.tzld.piaoquan.abtest.client.model.GetExpResponse getExp(com.tzld.piaoquan.abtest.client.model.GetExpRequest request) {
      return blockingUnaryCall(
          getChannel(), getGetExpMethod(), getCallOptions(), request);
    }
  }

  /**
   */
  public static final class ExpServiceFutureStub extends io.grpc.stub.AbstractFutureStub<ExpServiceFutureStub> {
    private ExpServiceFutureStub(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      super(channel, callOptions);
    }

    @java.lang.Override
    protected ExpServiceFutureStub build(
        io.grpc.Channel channel, io.grpc.CallOptions callOptions) {
      return new ExpServiceFutureStub(channel, callOptions);
    }

    /**
     */
    public com.google.common.util.concurrent.ListenableFuture<com.tzld.piaoquan.abtest.client.model.GetExpResponse> getExp(
        com.tzld.piaoquan.abtest.client.model.GetExpRequest request) {
      return futureUnaryCall(
          getChannel().newCall(getGetExpMethod(), getCallOptions()), request);
    }
  }

  private static final int METHODID_GET_EXP = 0;

  private static final class MethodHandlers<Req, Resp> implements
      io.grpc.stub.ServerCalls.UnaryMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ServerStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.ClientStreamingMethod<Req, Resp>,
      io.grpc.stub.ServerCalls.BidiStreamingMethod<Req, Resp> {
    private final ExpServiceImplBase serviceImpl;
    private final int methodId;

    MethodHandlers(ExpServiceImplBase serviceImpl, int methodId) {
      this.serviceImpl = serviceImpl;
      this.methodId = methodId;
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public void invoke(Req request, io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        case METHODID_GET_EXP:
          serviceImpl.getExp((com.tzld.piaoquan.abtest.client.model.GetExpRequest) request,
              (io.grpc.stub.StreamObserver<com.tzld.piaoquan.abtest.client.model.GetExpResponse>) responseObserver);
          break;
        default:
          throw new AssertionError();
      }
    }

    @java.lang.Override
    @java.lang.SuppressWarnings("unchecked")
    public io.grpc.stub.StreamObserver<Req> invoke(
        io.grpc.stub.StreamObserver<Resp> responseObserver) {
      switch (methodId) {
        default:
          throw new AssertionError();
      }
    }
  }

  private static abstract class ExpServiceBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoFileDescriptorSupplier, io.grpc.protobuf.ProtoServiceDescriptorSupplier {
    ExpServiceBaseDescriptorSupplier() {}

    @java.lang.Override
    public com.google.protobuf.Descriptors.FileDescriptor getFileDescriptor() {
      return com.tzld.piaoquan.abtest.client.model.Exp.getDescriptor();
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.ServiceDescriptor getServiceDescriptor() {
      return getFileDescriptor().findServiceByName("ExpService");
    }
  }

  private static final class ExpServiceFileDescriptorSupplier
      extends ExpServiceBaseDescriptorSupplier {
    ExpServiceFileDescriptorSupplier() {}
  }

  private static final class ExpServiceMethodDescriptorSupplier
      extends ExpServiceBaseDescriptorSupplier
      implements io.grpc.protobuf.ProtoMethodDescriptorSupplier {
    private final String methodName;

    ExpServiceMethodDescriptorSupplier(String methodName) {
      this.methodName = methodName;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.MethodDescriptor getMethodDescriptor() {
      return getServiceDescriptor().findMethodByName(methodName);
    }
  }

  private static volatile io.grpc.ServiceDescriptor serviceDescriptor;

  public static io.grpc.ServiceDescriptor getServiceDescriptor() {
    io.grpc.ServiceDescriptor result = serviceDescriptor;
    if (result == null) {
      synchronized (ExpServiceGrpc.class) {
        result = serviceDescriptor;
        if (result == null) {
          serviceDescriptor = result = io.grpc.ServiceDescriptor.newBuilder(SERVICE_NAME)
              .setSchemaDescriptor(new ExpServiceFileDescriptorSupplier())
              .addMethod(getGetExpMethod())
              .build();
        }
      }
    }
    return result;
  }
}
