package com.tzld.piaoquan.abtest.model;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.List;
import java.util.Map;

/**
 * @author dyp
 */
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
public class ExpConfig {
    private String appType;
    private List<Layer> layers;


    @Getter
    @Setter
    @NoArgsConstructor
    @AllArgsConstructor
    public static class Layer {
        private String layerId;
        private int bucketNum;
        private List<Exp> exps;
        private Map<String, String> groupRule;
    }

    @Getter
    @Setter
    @NoArgsConstructor
    @AllArgsConstructor
    public static class Exp {
        private String expId;
        private int[] range;
    }
}
